#include "signalbox.h"
#include "ui_signalbox.h"

#include "stdio.h"

SignalBox::SignalBox(QWidget *parent) :
    QDialog(parent),
    ui(new Ui::SignalBox)
{
    ui->setupUi(this);
}

SignalBox::~SignalBox()
{
    delete ui;
}

void SignalBox::showEvent(QShowEvent *event)
{
    char	str[256];
    int		extsign=0,vidcolor=-1;
    int		ret;
    QString     qs;
//    BOOL	IsCameraDll();

    qs = "当前视频输入信息";
    qs += "     (";
    okGetTypeCode(hBoard, str);
    qs += str;
    qs += ")";
    this->setWindowTitle(qs);

    //scanlines=okSetVideoParam(hBoard,VIDEO_FRAMELINES,-1); //just for cards with D/A
    //okSetVideoParam(hBoard,VIDEO_FRAMELINES,scanlines); //init to extern sync
    //video exist
    ui->pushButton_AUTOSEARCH->setEnabled(true);

    extsign=okGetSignalParam(hBoard,SIGNAL_VIDEOEXIST);
    if(extsign==1) {
        qs = "检测到了信号源";
    }
    else if(extsign==0) {
        qs = "没有信号源";
    }
    else {//-1
        qs = "不支持";
        ui->pushButton_AUTOSEARCH->setEnabled(false);
    }

    vidcolor=okGetSignalParam(hBoard,SIGNAL_VIDEOCOLOR);
    if(extsign==1) {

        if(vidcolor==1)
            qs += "(Color)";
        else if(vidcolor==0)
            qs += "(B/W)";
    }
    ui->label_VIDEOEXIST->setText(qs);

    //video type
    if(extsign==1) {
        okWaitSignalEvent(hBoard, EVENT_ODDFIELD, 40);
        videotype=okGetSignalParam(hBoard,SIGNAL_VIDEOTYPE);
        if(videotype==1) //interlaced
            qs = "隔行信号(Interlaced)";
        else if(videotype==0) //non-interlaced
            qs = "逐行信号(Progressive)";
        else if(videotype==-1)
            qs = "不支持";


    }
    else
        qs = "未知";

    ui->label_VIDEOTYPE->setText(qs);

    //video scanlines
    scanlines=-1;
    if(extsign==1) {
        scanlines=okGetSignalParam(hBoard,SIGNAL_SCANLINES);
        if(scanlines==-1)
            qs = "不支持";
        else {
            sprintf(str,"%d ",scanlines);
            qs = str;
            qs += "行数/幅";
        }
    }
    else
        qs = "未知";
    ui->label_SCANLINES->setText(qs);

    //video field frequency
    if(extsign==1) {
        fieldfrq=okGetSignalParam(hBoard,SIGNAL_FIELDFREQ);
        if(fieldfrq==-1)
            qs = "不支持";
        else {
            sprintf(str,"%d ",fieldfrq);
            qs = str;
            qs += "场数/秒";
        }
    }
    else if(extsign==-1)
        qs = "未知";
    ui->label_FRAMEFREQ->setText(qs);


    //extern trigger
    ret=okGetSignalParam(hBoard,SIGNAL_EXTTRIGGER);


    if(ret==-1)
        qs = "不支持";
    else if(ret)
        qs = "触发状态";
    else
        qs = "无触发";
    ret=okGetSignalParam(hBoard,SIGNAL_CAPFINISHED);
    if(ret!=-1) { //supported
        if(ret==1)
            qs += ";      Captured";
        else
            qs += ";      No Captured";
    }
    ui->label_EXTTRIGGER->setText(qs);

    ui->radioButton_SAMPLERATIO43->setChecked(true);
    //firstly assume that can not detect signal infos
    ui->pushButton_SETVIDEO->setEnabled(false);
    ui->pushButton_AUTOFINESET->setEnabled(false);
    ui->radioButton_SAMPLERATIO43->setEnabled(false);
    ui->radioButton_SAMPLERATIO11->setEnabled(false);
    if(scanlines!=-1){
        ui->pushButton_SETVIDEO->setEnabled(true);
        ui->pushButton_AUTOFINESET->setEnabled(true);
        //if( okSetCaptureParam(hBoard,CAPTURE_HORZPIXELS,-1)!=-1 ) {
            ui->radioButton_SAMPLERATIO43->setEnabled(true);
            ui->radioButton_SAMPLERATIO11->setEnabled(true);
        //}
    }
    //if( (scanlines==625) && (videotype==1) || // PAL
    //	(scanlines==525) && (videotype==1) ) { //NTSC
    //	EnableWindow(GetDlgItem(hDlg,IDC_SAMPLERATIO43),FALSE);
    //	EnableWindow(GetDlgItem(hDlg,IDC_SAMPLERATIO11),FALSE);
    //}

    //test out trigger
    okPutSignalParam(hBoard,PUTSIGNAL_TRIGGER,0xff);

    //enable vert sync
    okPutSignalParam(hBoard,PUTSIGNAL_VERTSYNC,0x1);
}

void SignalBox::SetBoard(HANDLE h)
{
    hBoard = h;
}
